SystemOrganization addCategory: #'Arduino-EtoysCompiler'!

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/15/2011 12:58'!
detectMainMorph
	"Looks for the arduino board in which it is connected and returns it"
	World allMorphsDo: [:morph |
		((morph isKindOf: ArduinoMorph) and: [self isAttachedTo: morph])
			ifTrue: [^ morph]
		].
	^ self error: 'The device is not properly attached to any arduino'! !

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/15/2011 10:21'!
download: anArduinoCTranslatedProgram
	^ self detectMainMorph download: anArduinoCTranslatedProgram! !

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/15/2011 16:20'!
isAttachedTo: anArduinoMorph 
	^ device isAttachedToArduino: anArduinoMorph arduino! !

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/15/2011 10:21'!
playerTranslator
	^ self detectMainMorph playerTranslator! !

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 3/30/2012 18:57'!
translateScriptNamed: scriptName
	^ self detectMainMorph translateScriptNamed: scriptName of: self! !

!ArduinoSketch methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 12/27/2011 17:53'!
getBooleanValue: pinNumber
	<returnType: #(CBoolean)>
	<argTypes: #(CLong)>
	<c: 'getBooleanValue({1})'>! !

!ArduinoSketch methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 1/2/2012 17:43'!
getDCMotorSpeedD0: d0 d1: d1 en: en
	<argTypes: #(CLong CLong Clong)>
	<returnType: #(CLong)>
	<c: 'getDCMotorSpeed({1}, {2}, {3})'>! !

!ArduinoSketch methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 12/27/2011 17:52'!
getMode: pinNumber
	<returnType: #(CByte)>
	<argTypes: #(CLong)>
	<c: 'getMode({1})'>! !

!ArduinoSketch methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 12/27/2011 17:53'!
getValue: pinNumber
	<returnType: #(CLong)>
	<argTypes: #(CLong)>
	<c: 'getValue({1})'>! !

!ArduinoSketch methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 12/27/2011 17:54'!
setBooleanValue: pinNumber value: value
	<argTypes: #(CLong CBoolean)>
	<c: 'setBooleanValue({1}, {2})'>! !

!ArduinoSketch methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 1/2/2012 17:20'!
setDCMotorSpeed: speed d0: d0 d1: d1 en: en
	<argTypes: #(CLong CLong CLong Clong)>
	<c: 'setDCMotorSpeed({1}, {2}, {3}, {4})'>! !

!ArduinoSketch methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 12/27/2011 17:53'!
setMode: pinNumber value: value
	<argTypes: #(CLong CByte)>
	<c: 'setMode({1}, {2})'>! !

!ArduinoSketch methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 12/27/2011 17:54'!
setValue: pinNumber value: value
	<argTypes: #(CLong CLong)>
	<c: 'setValue({1}, {2})'>! !

!ArduinoMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 2/29/2012 12:45'!
detectMainMorph
	^ self! !

!ArduinoMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 10/23/2012 13:23'!
download: anArduinoCTranslatedProgram
	[[anArduinoCTranslatedProgram 
		uploadOnPort: portName 
		arduinoType: self arduinoType]
		on: CompilingSketchError
		do: [:err | 
			"This should *never* happen, but if it does
			it would be good to see the error"
			PEUtilities
				showSyntaxError: err messageText
				translatedCode: anArduinoCTranslatedProgram asStringWithLineNumbers
				originalCode: (Smalltalk at: self playerTranslator programName) sourceCode]]
		on: Error
		do: [:err | self inform: err description]! !

!ArduinoMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:08'!
playerTranslator
	^ ArduinoPlayerTranslator on: self! !

!ArduinoMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 3/30/2012 18:57'!
translateScriptNamed: scriptName
	^ self translateScriptNamed: scriptName of: self! !

!ArduinoMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 3/30/2012 18:59'!
translateScriptNamed: scriptName of: aMorph
	"First asks the player translator to merge all the players into one
	ArduinoSketch subclass. Then generates the C++ code"
	^ (self playerTranslator translateMainScript: scriptName of: aMorph)
			translatedToArduinoC: #main! !

ArduinoProtocol subclass: #ArduinoCompiledMode
	instanceVariableNames: 'isConnected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-EtoysCompiler'!

!ArduinoCompiledMode methodsFor: 'analog pins' stamp: 'Richo 12/23/2011 16:37'!
activateAnalogPin: pinNumber
"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'digital pins' stamp: 'Richo 12/23/2011 16:38'!
activateDigitalPort: portNumber
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'analog pins' stamp: 'Richo 12/23/2011 16:37'!
analogRead: pinNumber
	"Do nothing"
	^ 0! !

!ArduinoCompiledMode methodsFor: 'analog pins' stamp: 'Richo 12/27/2011 15:31'!
analogWrite: pin value: value
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'servos' stamp: 'Richo 12/23/2011 16:39'!
attachServoToPin: pinNumber
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'connection' stamp: 'Richo 12/23/2011 16:39'!
connectOnPort: portName boardType: anArduinoType
	isConnected := true! !

!ArduinoCompiledMode methodsFor: 'analog pins' stamp: 'Richo 12/23/2011 16:37'!
deactivateAnalogPin: pinNumber
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'digital pins' stamp: 'Richo 12/23/2011 16:38'!
deactivateDigitalPort: portNumber
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'servos' stamp: 'Richo 12/23/2011 16:39'!
detachServoFromPin: pinNumber
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'digital pins' stamp: 'Richo 12/23/2011 16:38'!
digitalPin: pinNumber mode: mode
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'digital pins' stamp: 'Richo 12/23/2011 16:38'!
digitalRead: pinNumber
	"Do nothing"
	^ 0! !

!ArduinoCompiledMode methodsFor: 'digital pins' stamp: 'Richo 12/23/2011 16:39'!
digitalWrite: pinNumber value: value
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'connection' stamp: 'Richo 12/23/2011 16:39'!
disconnect
	isConnected := false! !

!ArduinoCompiledMode methodsFor: 'testing' stamp: 'Richo 12/23/2011 15:11'!
isCompiled
	^ true! !

!ArduinoCompiledMode methodsFor: 'connection' stamp: 'Richo 12/23/2011 16:45'!
isConnected
	^ isConnected ifNil: [false]! !

!ArduinoCompiledMode methodsFor: 'accessing' stamp: 'Richo 12/23/2011 16:29'!
nameSymbol
	^ #compiled! !

!ArduinoCompiledMode methodsFor: 'servos' stamp: 'Richo 12/23/2011 16:39'!
servoOnPin: pinNumber angle: degrees
	"Do nothing"! !

!ArduinoCompiledMode methodsFor: 'pin modes' stamp: 'Richo 12/23/2011 16:40'!
valueForInputMode
	"Do nothing"
	^ 0! !

!ArduinoCompiledMode methodsFor: 'pin modes' stamp: 'Richo 12/23/2011 16:40'!
valueForOutputMode
	"Do nothing"
	^ 0! !

!ArduinoCompiledMode methodsFor: 'pin modes' stamp: 'Richo 12/23/2011 16:40'!
valueForPwmMode
	"Do nothing"
	^ 0! !

!ArduinoCompiledMode methodsFor: 'pin modes' stamp: 'Richo 12/23/2011 16:40'!
valueForServoMode
	"Do nothing"
	^ 0! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 12/23/2011 16:16'!
getArduinoMode
	^ self costume renderedMorph mode nameSymbol! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:08'!
isUsingCompiledMode
	"An error might be signaled if this message is sent to an unplugged device"
	^ [self costume renderedMorph detectMainMorph isUsingCompiledMode] on: Error do: [false]! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:09'!
newScriptorAround: aPhrase
	| scriptEditor |
	Transcript show: 'newScriptorAround:'; cr.
	^ scriptEditor := super newScriptorAround: aPhrase.
	"^ NxtScriptEditorMorph fromScriptEditor: scriptEditor phrase: aPhrase"! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:09'!
scriptEditorFor: aSelector
	Transcript show: 'scriptEditorFor:'; cr.
	^ super scriptEditorFor: aSelector! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:09'!
scriptEditorForNoCng: aSelector
	Transcript show: 'scriptEditorForNoCng:'; cr.
	^ super scriptEditorForNoCng: aSelector.! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 2/29/2012 12:30'!
setArduinoMode: aSymbol
	self getArduinoMode = aSymbol ifTrue: [^self].
	self costume renderedMorph
		mode: (aSymbol caseOf: {
			[#firmata] -> [Firmata new].
			[#direct] -> [ArduinoDirectMode new].
			[#compiled] -> [ArduinoCompiledMode new].
			} otherwise: [^self]).
	self updateScriptEditors! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 2/29/2012 12:49'!
updateScriptEditors
	"Horrible hack below"
	World allMorphsDo: [:morph | | viewer |
		"Update scripts category of all opened viewers"
		((morph isKindOf: StandardViewer)
		and: [morph playerScripted isKindOf: self class officialClass]) 
			ifTrue: [morph updateScriptsCategory].
		"Also update closed viewers"
		((morph isKindOf: ViewerFlapTab) and: [(viewer := morph referent findA: StandardViewer) notNil])
			ifTrue: [viewer updateScriptsCategory].
		"Finally, update all opened script editors"
		((morph isKindOf: ScriptEditorMorph)
		and: [morph playerScripted isKindOf: self class officialClass]) 
			ifTrue: [morph replaceRow1; minWidth: nil]]! !

PlayerTranslator subclass: #ArduinoPlayerTranslator
	instanceVariableNames: 'digitalPins analogPins'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-EtoysCompiler'!

!ArduinoPlayerTranslator class methodsFor: 'accessing' stamp: 'Richo 1/3/2012 15:50'!
allPrimitiveRulesSelectors
	^ Array streamContents: [:stream || current |
		"Collect all selectors in the ArduinoSketch protocol..."
		current := ArduinoSketch.
		[stream nextPutAll: current selectors]
			doWhileTrue: [(current := current superclass) ~= CObject superclass].
		"... and in all the primitive types' protocol as well"
		CPrimitiveType withAllSubclassesDo: [:class |
			stream nextPutAll: class selectors]]! !

!ArduinoPlayerTranslator class methodsFor: 'instance creation' stamp: 'Richo 8/11/2011 17:21'!
on: anArduinoMorph 
	^ self basicNew
			initializeWith: anArduinoMorph;
			yourself! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/3/2012 15:04'!
allMorphs
	"Returns a collection with all the morphs composing the robot (it could contain nils)"
	^ ({mainMorph}, 
		digitalPins values flattened, 
		analogPins values flattened) asSet! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 3/27/2012 11:42'!
arduinoIndexOf: aVariableNode
	"First we look in the digital pins"	
	| index |
	index := self arduinoIndexOf: aVariableNode in: digitalPins.
	index notNil ifTrue: [^ index].
	"If we haven't found the variable yet we look in the analog pins"
	index := self arduinoIndexOf: aVariableNode in: analogPins.
	self assert: index notNil.
	^ index + 14
! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 3/27/2012 11:24'!
arduinoIndexOf: aVariableNode in: aCollection
	"Basically, it tries to determine if the variable node is representing an object in the collection. If it is, it returns its index"
	| index findIndex |
	findIndex := [:morph || ret |
		ret := nil.
		aCollection keysAndValuesDo: [:key :value |
			(value includes: morph)
				ifTrue: [ret := key]
			].
		ret].
	aVariableNode name = 'self' 
		ifTrue: [index := findIndex value: currentMorph]
		ifFalse: [index := findIndex value: (self morphFor: aVariableNode name)].
	"^ index isNil ifTrue: [self error: 'Index not found'] ifFalse: [index]."
	^ index
! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 3/30/2012 17:57'!
classCategory
	^ 'ArduinoPrograms'! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 3/30/2012 17:57'!
classIncludes
	^ #('"PhysicalEtoys.h"')! !

!ArduinoPlayerTranslator methodsFor: 'initializing' stamp: 'Richo 3/30/2012 17:42'!
collectMorphs
	"Finds out which device morphs are connected to the arduino in which pins (digital or analog).
	It's not the cleanest way of doing it but it works..."
	| arduino |
	arduino := mainMorph arduino.
	digitalPins := ((2 to: 13)
		collect: [:n | n -> OrderedCollection new]) as: Dictionary.
	analogPins := ((0 to: 5)
		collect: [:n | n -> OrderedCollection new]) as: Dictionary.
	World allMorphsDo: [:morph |
		((morph isKindOf: AttachableDeviceMorph)
		and: [morph isAttachedTo: mainMorph])
			ifTrue: [
				arduino digitalPins do: [:pin |
					(morph device isAttachedToPin: pin)
						ifTrue: [(digitalPins at: pin number) add: morph]
				].
				arduino analogPins do: [:pin |
					(morph device isAttachedToPin: pin)
						ifTrue: [(analogPins at: pin number) add: morph]
				]
		]
	]! !

!ArduinoPlayerTranslator methodsFor: 'accessing-rules' stamp: 'Richo 12/29/2011 19:09'!
commonDevicesRules
| selfVar booleanGetter booleanSetter getter setter |
selfVar := self variable: 'self'.
booleanGetter := [:node |
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node arguments: {self literal: (self arduinoIndexOf: node receiver)};
			selector: #getBooleanValue:;
			receiver: selfVar].
	super acceptMessageNode: node].
booleanSetter := [:node | 
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node arguments: {self literal: (self arduinoIndexOf: node receiver)},
							node arguments;
			selector: #setBooleanValue:value:;
			receiver: selfVar].
	super acceptMessageNode: node].
getter := [:node |
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node arguments: {self literal: (self arduinoIndexOf: node receiver)};
			selector: #getValue:;
			receiver: selfVar].
	super acceptMessageNode: node].
setter := [:node | 
	self withCurrentMorph: (self morphFor: node receiver name) do: [
		node arguments: {self literal: (self arduinoIndexOf: node receiver)},
							node arguments;
			selector: #setValue:value:;
			receiver: selfVar].
	super acceptMessageNode: node].
^ {
	"LED"
	#getIsLedOn -> booleanGetter.
	#setIsLedOn: -> booleanSetter.
	"Pushbutton"
	#getIsPressed -> booleanGetter.
	"Switch"
	#getIsOn -> booleanGetter.
	"Tilt switch"
	#getTiltValue -> getter.
	"Photoresistor/Optocoupler"
	#getLightValue -> getter.
	"Potentiometer"
	#getPotentiometerValue -> getter.
	"Thermistor"
	#getTemperatureValue -> getter.
	"Pwm led"
	#setLedValue: -> setter.
	#getLedValue -> getter.
	"Buzzer"
	#setBuzzerValue:  -> setter.
	#getBuzzerValue -> getter.
	"Relay"
	#getIsRelayOpen -> booleanGetter.
	#setIsRelayOpen: -> booleanSetter.
	"Servo"
	#getDegrees -> getter.
	#setDegrees: -> setter.
}! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 3/30/2012 17:56'!
commonSuperclass
	^ ArduinoSketch! !

!ArduinoPlayerTranslator methodsFor: 'translating' stamp: 'Richo 12/29/2011 18:52'!
compileSetUpMethod
| methodSource |
methodSource := WriteStream on: ''.
methodSource nextPutAll: 'setup'; cr.
"Configure sensors"
digitalPins keysAndValuesDo: [:key :value |
	value notEmpty
		ifTrue: [| mode |
		mode := (mainMorph arduino digitalPin: key) mode.
		methodSource
			nextPutAll: 'self setMode: ';
			nextPutAll: key asString;
			nextPutAll: 'value:';
			space;
			nextPutAll: (true caseOf: {
				[mode isServo] -> ['3'].
				[mode isPwm] -> ['2'].
				[mode isOutput] -> ['1'].
				[mode isInput] -> ['0']
				});
			nextPutAll: '.';
			cr.
	]
].
analogPins keysAndValuesDo: [:key :value |
	value notEmpty
		ifTrue: [| mode |
		mode := (mainMorph arduino analogPin: key) mode.
		methodSource
			nextPutAll: 'self setMode:';
			nextPutAll: (key + 14) asString;
			nextPutAll: 'value:';
			space;
			nextPutAll: (true caseOf: {
				[mode isPwm] -> ['2'].
				[mode isOutput] -> ['1'].
				[mode isInput] -> ['0']
				});
			nextPutAll: '.';
			cr.
	]
].


"Initialize variables"
self variablesDo: [:varName :varTypeAndValue | | value |
	value := varTypeAndValue value.
	value := (value isKindOf: RBProgramNode) 
				ifTrue: [value formattedCode]  "Is a message send"
				ifFalse: [value printString]. "Is a literal"
	methodSource 
		nextPutAll: (self asLegalName: varName), ' := ' , value , '.';
		cr].
methods add: methodSource contents! !

!ArduinoPlayerTranslator methodsFor: 'accessing-rules' stamp: 'Richo 1/2/2012 17:43'!
dcMotorRules
	| selfVar |
	selfVar := self variable: 'self'.
	^ {
		#getSpeed -> [:node | 
			self withCurrentMorph: (self morphFor: node receiver name)
				do: [| device |
				device := currentMorph device.
				node arguments: {self literal: device d0Pin number.
						self literal: device d1Pin number.
						self literal: device enablePin number};
					selector: #getDCMotorSpeedD0:d1:en:;
					receiver: selfVar].
			super acceptMessageNode: node].
		#setSpeed: -> [:node | 	
			self withCurrentMorph: (self morphFor: node receiver name)
				do: [| device |
				device := currentMorph device.
				node arguments: node arguments,
						{self literal: device d0Pin number.
						self literal: device d1Pin number.
						self literal: device enablePin number};
					selector: #setDCMotorSpeed:d0:d1:en:;
					receiver: selfVar].
			super acceptMessageNode: node].
		}! !

!ArduinoPlayerTranslator methodsFor: 'initializing' stamp: 'Richo 10/21/2011 16:33'!
initialize
	super initialize.
	self collectRelevantInformation! !

!ArduinoPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 8/16/2011 12:25'!
programName
	^ #ArduinoEtoysProgram! !

!ArduinoPlayerTranslator methodsFor: 'accessing-rules' stamp: 'Richo 4/10/2012 13:24'!
rules
"These are the rules to modify the parse tree of the ArduinoPlayer scripts. Most of the time, I just need to rename the selector, change the receiver to self and set the correct list of arguments. Other times the rule is a little more complicated"
^ super rules, ((
	self commonDevicesRules,
	self dcMotorRules
	) as: Dictionary)! !
